import { Component, Input, NgModule } from '@angular/core';
import { createElement } from 'react';
import { render, unmountComponentAtNode } from 'react-dom';
var uniqueId = 0;
var ReactWrapperComponent = /** @class */ (function () {
    function ReactWrapperComponent() {
    }
    /**
     * @return {?}
     */
    ReactWrapperComponent.prototype.ngOnInit = function () {
        this.id = 'React_' + uniqueId++;
    };
    /**
     * @return {?}
     */
    ReactWrapperComponent.prototype.ngAfterViewInit = function () {
        this.node = document.getElementById(this.id);
        this.render();
    };
    /**
     * @return {?}
     */
    ReactWrapperComponent.prototype.ngOnChanges = function () {
        console.log('ngOnChanges');
        if (this.node) {
            this.render();
        }
    };
    /**
     * @return {?}
     */
    ReactWrapperComponent.prototype.ngOnDestroy = function () {
        console.log('ngOnDestroy');
        if (this.node) {
            this.destroy();
        }
    };
    /**
     * @return {?}
     */
    ReactWrapperComponent.prototype.render = function () {
        render(createElement(this.component, this.props), this.node);
    };
    /**
     * @return {?}
     */
    ReactWrapperComponent.prototype.destroy = function () {
        unmountComponentAtNode(this.node);
    };
    return ReactWrapperComponent;
}());
ReactWrapperComponent.decorators = [
    { type: Component, args: [{
                selector: 'r2a-react-wrapper',
                template: "<div [id]=\"id\"></div>"
            },] },
];
/**
 * @nocollapse
 */
ReactWrapperComponent.ctorParameters = function () { return []; };
ReactWrapperComponent.propDecorators = {
    'component': [{ type: Input },],
    'props': [{ type: Input },],
};
var ReactWrapperModule = /** @class */ (function () {
    function ReactWrapperModule() {
    }
    return ReactWrapperModule;
}());
ReactWrapperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [ReactWrapperComponent],
                exports: [ReactWrapperComponent]
            },] },
];
/**
 * @nocollapse
 */
ReactWrapperModule.ctorParameters = function () { return []; };
/**
 * Generated bundle index. Do not edit.
 */
export { ReactWrapperModule, ReactWrapperComponent as ɵa };
//# sourceMappingURL=react-to-angular.es5.js.map
