import { Component, Input, NgModule } from '@angular/core';
import { createElement } from 'react';
import { render, unmountComponentAtNode } from 'react-dom';

let uniqueId = 0;
class ReactWrapperComponent {
    /**
     * @return {?}
     */
    ngOnInit() {
        this.id = 'React_' + uniqueId++;
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.node = document.getElementById(this.id);
        this.render();
    }
    /**
     * @return {?}
     */
    ngOnChanges() {
        console.log('ngOnChanges');
        if (this.node) {
            this.render();
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        console.log('ngOnDestroy');
        if (this.node) {
            this.destroy();
        }
    }
    /**
     * @return {?}
     */
    render() {
        render(createElement(this.component, this.props), this.node);
    }
    /**
     * @return {?}
     */
    destroy() {
        unmountComponentAtNode(this.node);
    }
}
ReactWrapperComponent.decorators = [
    { type: Component, args: [{
                selector: 'r2a-react-wrapper',
                template: `<div [id]="id"></div>`
            },] },
];
/**
 * @nocollapse
 */
ReactWrapperComponent.ctorParameters = () => [];
ReactWrapperComponent.propDecorators = {
    'component': [{ type: Input },],
    'props': [{ type: Input },],
};

class ReactWrapperModule {
}
ReactWrapperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [ReactWrapperComponent],
                exports: [ReactWrapperComponent]
            },] },
];
/**
 * @nocollapse
 */
ReactWrapperModule.ctorParameters = () => [];

/**
 * Generated bundle index. Do not edit.
 */

export { ReactWrapperModule, ReactWrapperComponent as ɵa };
//# sourceMappingURL=react-to-angular.js.map
